//
// ****************************************** Licence and Disclaimer ******************************************** //
//
// DosiVox is provided under the terms and conditions of the DosiVox Software License (GNU GPL3), included in
// the file DosiVox_Software_Licence and available at http://www.iramat-crp2a.cnrs.fr/spip/spip.php?//article144.
//
// Neither the authors of this software system, nor their employing institutes,nor the agencies providing
// financial support for this  work  make  any representation or  warranty, express or implied, regarding 
// this  software system or assume any liability for its use.  Please see the license in the file
// DosiVox_Software_Licence  and URL above for the full disclaimer and the limitation of liability.
//
// By using,  copying,  modifying or  distributing the software (or any work based  on the software)  you 
// agree  to acknowledge its use  in  resulting acceptance of all terms of the DosiVox Software license.
//
// DosiVox (version 1.0 )is a free software (GNU GPL3 licence, see above) based on the Geant4 C++ libraries
// (available at  http://geant4.org/ and responding to the Geant4 Software Licence available at 
// http://cern.ch/geant4/license) (version Geant4 10.1). It is developed by L.Martin, N.Mercier and S.Incerti at
// the IRAMAT-CRP2A,the CENBG and the university Bordeaux-Montaigne. DosiVox allows constructing voxelised models
// of archeological objects and simulating the radioactivity for dose calculation with a Monte-Carlo approach. 
// These dose geometry and parameters, allowing to create simulation by writing or editing a text file. DosiVox is 
// developped and tested on a Scientific Linux (Red Hat) virtual machine available at 
// http://geant4.in2p3.fr/spip.php?rubrique8 .
// ************************************************************************************************************** //
//
// Please cite the following paper if you use this software:
// Martin, L., Incerti, S., Mercier, N., 2015. 
// DosiVox : a Geant 4-based software for dosimetry simulations relevant to luminescence and ESR dating techniques. 
// Ancient TL 33, 1-10. 

#ifndef SteppingAction_h
#define SteppingAction_h 1

#include "G4UserSteppingAction.hh"
#include "G4Step.hh"
#include "G4Track.hh"
#include "G4Material.hh"
#include "G4StepPoint.hh"
#include "G4VTouchable.hh"
#include "G4SteppingManager.hh"
#include "G4TransportationManager.hh"
#include "G4Navigator.hh"
#include "G4PathFinder.hh"
#include "PrimaryGeneratorAction.hh"
#include "RunAction.hh"

class RunAction;
class PrimaryGeneratorAction;
class ParametersSetting;
class G4Navigator;
class G4PathFinder;

class SteppingAction : public G4UserSteppingAction
{

 public:
      
  SteppingAction(RunAction*,PrimaryGeneratorAction*);
  virtual ~SteppingAction();

  virtual void UserSteppingAction(const G4Step*);
    
 private:

  G4int fNvoxX,fNvoxY,fDetvoxX,fDetvoxY,DetVox,DetDef,security,ProbeWorldID, WorldID ;
  G4double ProbeRadius, POffSetX, POffSetY, E_lost; 
  G4bool VoxelSafety;
  G4String MatDet, DetMatName, ErrorFile; 

  G4StepPoint* point1;
  G4Material* DetMat;

  RunAction* RunAct ;  
  PrimaryGeneratorAction* myPrimGenAction;    					    
    
};

#endif

